from os import getcwd
from subprocess import PIPE, Popen

from pycmd_public import appearance, behavior, abbrev_path
from pycmd_public import color


appearance.colors.text = ''
appearance.colors.prompt = color.Fore.TOGGLE_BRIGHT

appearance.colors.selection = (color.Fore.TOGGLE_RED +
                               color.Fore.TOGGLE_GREEN +
                               color.Fore.TOGGLE_BLUE +
                               color.Back.TOGGLE_RED +
                               color.Back.TOGGLE_GREEN +
                               color.Back.TOGGLE_BLUE)

appearance.colors.search_filter = (color.Back.TOGGLE_RED +
                                   color.Back.TOGGLE_BLUE +
                                   color.Fore.TOGGLE_BRIGHT)

appearance.colors.completion_match = color.Fore.TOGGLE_RED

appearance.colors.dir_history_selection = (color.Fore.TOGGLE_BRIGHT +
                                           color.Back.TOGGLE_BRIGHT)


def full_path():
    path = getcwd().decode(sys.getfilesystemencoding())
    return path[0].upper() + path[1:]


def full_path_prompt():
    return full_path() + u'> '


def git_branch_name():
    stdout = Popen(
        'git branch | grep "^*"',
        shell=True,
        stdout=PIPE,
        stderr=-1).communicate()[0]
    return stdout.strip(' \n\r*')


def git_abbrev_prompt():
    branch_name = git_branch_name()
    path = abbrev_path()

    # The current color setting is defined by appearance.colors.prompt
    prompt = ''
    if branch_name != '':
        prompt += color.Fore.TOGGLE_BLUE + '[' + branch_name + ']' + color.Fore.TOGGLE_BLUE + ' '
    prompt += path + '> '

    return prompt


def git_full_prompt():
    branch_name = git_branch_name()
    path = full_path()

    # The current color setting is defined by appearance.colors.prompt
    prompt = ''
    if branch_name != '':
        prompt += color.Fore.TOGGLE_BLUE + '[' + branch_name + ']' + color.Fore.TOGGLE_BLUE + ' '
    prompt += path + '> '

    return prompt


# appearance.prompt = pycmd_public.abbrev_path_prompt
appearance.prompt = full_path_prompt

behavior.quiet_mode = True
behavior.completion_mode = 'bash'
